PDF rendering improvements when exporting an issue or a list of issues
Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: PDF export Estimated time: 0.00 hour

Target version: 5.0.0   

Resolution:    

Description

Two PDF generation improvements:

1. Currently, when rendering an issue PDF, macros are only expanded in the description, but not when rendering custom fields with

fulltext formatting enabled. The patch changes the behaviour so that formatted full-width custom fields are rendered in the same way

the description is rendered, fully interpreting macros. The behaviour for rendering normal-width custom fields is unchanged, probably

it is better to leave it as is due to space constraints.

2. Thumbnail macro output was not rendered properly (in the issue description and elsewhere) because the thumbnail image file

could not be retrieved - the second patch extends get_image_filename to check for thumbnail URLs and retrieve the proper file path

in that case.

Both patches were initially developed for Planio .

Related issues:

Related to Redmine - Defect #34709: No Images in PDF export of issue list (wi... Closed

Associated revisions

Revision 21211 - 2021-09-06 21:19 - Marius BĂLTEANU

Expand macros in full-width custom fields when exporting issue to PDF (#35683).

Patch by Jens Krämer.

Revision 21212 - 2021-09-06 21:21 - Marius BĂLTEANU

Retrieve filenames of thumbnails when rendering a PDF (#35683).

Patch by Jens Krämer.

Revision 21213 - 2021-09-06 21:22 - Marius BĂLTEANU

Interpret thumbnail macro in description, notes and formatted custom fields in issues list PDF export (35683).

Patch by Jens Krämer.

Revision 21219 - 2021-09-11 12:08 - Marius BĂLTEANU

Disable Lint/DuplicateBranch in lib/redmine/export/pdf.rb#107 (#35683).

Revision 21220 - 2021-09-11 12:14 - Marius BĂLTEANU

Fix Layout/ClosingParenthesisIndentation offense (#35683).

History

#1 - 2021-08-06 23:30 - Mischa The Evil

- Target version set to Candidate for next minor release

Nice improvements.

#2 - 2021-08-16 14:36 - Go MAEDA

- Target version changed from Candidate for next minor release to 5.0.0
Setting the target version to 5.0.0.

#3 - 2021-08-24 09:08 - Jens Krämer

- File 0001-interpret-thumbnail-macro-in-description-notes-and-f.patch added

One more patch (based on the first two) which introduces the full rendering of last notes, description and formatted full width custom fields for the

tabular issues list PDF export.

#4 - 2021-08-25 03:09 - Mischa The Evil

- Status changed from New to Needs feedback

- Assignee set to Jens Krämer

Jens Krämer wrote:

One more patch (based on the first two) [...]

 Jens, I have only read the patch, but it seems to contain an error/typo. Shouldn't:

diff --git a/lib/redmine/export/pdf/issues_pdf_helper.rb b/lib/redmine/export/pdf/issues_pdf_helper.rb

index 98c7347ab..f55c80f5c 100644

--- a/lib/redmine/export/pdf/issues_pdf_helper.rb

+++ b/lib/redmine/export/pdf/issues_pdf_helper.rb

@@ -232,14 +225,7 @@ module Redmine

               if journal.notes?

                 pdf.ln unless journal.details.empty?

                 pdf.SetFontStyle('', 8)

-                text =

-                  textilizable(

-                    journal, :notes,

-                    :only_path => false,

-                    :edit_section_links => false,

-                    :headings => false,

-                    :inline_attachments => false

-                  )

+                text = pdf_format_text(issue, :description)

                 pdf.RDMwriteFormattedCell(190, 5, '', '', text, issue.attachments, "")

               end

               pdf.ln

 actually be:

diff --git a/lib/redmine/export/pdf/issues_pdf_helper.rb b/lib/redmine/export/pdf/issues_pdf_helper.rb

index 98c7347ab..f55c80f5c 100644

--- a/lib/redmine/export/pdf/issues_pdf_helper.rb

+++ b/lib/redmine/export/pdf/issues_pdf_helper.rb

@@ -232,14 +225,7 @@ module Redmine

               if journal.notes?

                 pdf.ln unless journal.details.empty?

                 pdf.SetFontStyle('', 8)

-                text =

-                  textilizable(

-                    journal, :notes,

-                    :only_path => false,

-                    :edit_section_links => false,

-                    :headings => false,

-                    :inline_attachments => false

-                  )

+                text = pdf_format_text(journal, :notes)

                 pdf.RDMwriteFormattedCell(190, 5, '', '', text, issue.attachments, "")

               end

               pdf.ln

 If so, then I think pdf_format_text would be better defined as something along the lines of:

diff --git a/lib/redmine/export/pdf/issues_pdf_helper.rb b/lib/redmine/export/pdf/issues_pdf_helper.rb

index 98c7347ab..f55c80f5c 100644

--- a/lib/redmine/export/pdf/issues_pdf_helper.rb

+++ b/lib/redmine/export/pdf/issues_pdf_helper.rb

@@ -375,6 +368,15 @@ module Redmine

           pdf.output

         end
+        def pdf_format_text(object, attribute)

+          textilizable(object, attribute,

+                       :only_path => false,

+                       :edit_section_links => false,

+                       :headings => false,

+                       :inline_attachments => false

+                      )

+        end

+

         def is_cjk?

           case current_language.to_s.downcase

           when 'ja', 'zh-tw', 'zh', 'ko'

#5 - 2021-08-25 11:46 - Jens Krämer

- File 0001-interpret-thumbnail-macro-in-description-notes-and-f.patch added

you're completely right, I attached an updated patch.

#6 - 2021-08-25 11:51 - Jens Krämer

- File 0001-interpret-thumbnail-macro-in-description-notes-and-f.patch added

Here it is, for real.

#7 - 2021-08-25 14:46 - Mischa The Evil

- File deleted (0001-interpret-thumbnail-macro-in-description-notes-and-f.patch)

#8 - 2021-08-25 14:47 - Mischa The Evil

- File deleted (0001-interpret-thumbnail-macro-in-description-notes-and-f.patch)

#9 - 2021-08-25 14:56 - Mischa The Evil

- Status changed from Needs feedback to New

- Assignee deleted (Jens Krämer)

Jens, thanks for the update. I've removed the faulty files to keep it clear.

@committers: the correct order of the patchset is:

1. 0001-render-formatted-full-width-custom-fields-in-the-sam.patch

2. 0001-retrieve-filenames-of-thumbnails-when-rendering-a-PD.patch

3. 0001-interpret-thumbnail-macro-in-description-notes-and-f.patch

#10 - 2021-09-06 21:23 - Marius BĂLTEANU

- Status changed from New to Resolved

- Assignee set to Marius BĂLTEANU

All three patches committed, thanks for the nice improvements.

#11 - 2021-09-06 21:24 - Marius BĂLTEANU

- Subject changed from PDF rendering improvements to PDF rendering improvements when exporting an issue or a list of issues

#12 - 2021-09-06 22:56 - Marius BĂLTEANU

- Status changed from Resolved to Closed

#13 - 2022-01-04 03:16 - Go MAEDA

- Related to Defect #34709: No Images in PDF export of issue list (with option show description) added

#14 - 2022-03-27 05:02 - Go MAEDA

- Tracker changed from Patch to Feature

Files
0001-retrieve-filenames-of-thumbnails-when-rendering-a-PD.patch 935 Bytes 2021-08-04 Jens Krämer

0001-render-formatted-full-width-custom-fields-in-the-sam.patch 1.53 KB 2021-08-04 Jens Krämer

0001-interpret-thumbnail-macro-in-description-notes-and-f.patch 4.46 KB 2021-08-25 Jens Krämer
